// ==============================================================
//               ORBITER MODULE: MaverickTech Routines
//                  Copyright (C) 2003 MaverickTech
//                        All rights reserved
//
// MavCode.cpp
//
// You are free to use this code as you wish.  If you use this
// code, please make sure it is published along with your own
// source code.
//
// I would like to know if you find this code useful, drop me
// an email at mavericktech@optusnet.com.au
//
// ==============================================================

#include "MavCode.h"

// Get the count of Thruster in each Thruster Group

int mavGetGroupThusterCount(VESSEL *vessel, THGROUP_TYPE thgt)
{
	int *thrustgrploc;				// Thruster Group location
	THGROUP_HANDLE thg;
	thg = vessel->GetThrusterGroupHandle(thgt);
	thrustgrploc = (int*)thg;
	return *(thrustgrploc+1);
}

//Return the Thruster Handle by Index for a Thruster Group

THRUSTER_HANDLE mavGetGroupThusterByIndex(VESSEL *vessel, THGROUP_TYPE thgt, int index)
{
	int *thrustgrploc;				// Thruster Group location
	int *thrustarray;				// Thrusters array
	int thrustloc;					// Thrusters location
	THGROUP_HANDLE thg;
	thg = vessel->GetThrusterGroupHandle(thgt);
	thrustgrploc = (int*)thg;
	if (index >= *(thrustgrploc+1))
	{
		return (THRUSTER_HANDLE*)0;
	}
	else
	{
		thrustloc = *thrustgrploc;
		thrustarray = (int*)(thrustloc + (4 * index));
		return *(THRUSTER_HANDLE*)(thrustarray);
	}
}

double mavGetGroupThrusterMax(VESSEL *vessel, THGROUP_TYPE thgt)
{
	int thrusttotal;
	double maxtally;

	THRUSTER_HANDLE th;

	maxtally = 0.0;

	thrusttotal = mavGetGroupThusterCount(vessel, thgt);
	for (int thrustcount = 0; thrustcount <= (thrusttotal - 1); thrustcount++)
	{
		th = mavGetGroupThusterByIndex(vessel, thgt, thrustcount);
		maxtally = maxtally + vessel->GetThrusterMax(th);
	}
	return maxtally;
}
